#include <iostream>
#include "dashBoard.h"
#include "subject.h"
#include "vehicle.h"

using namespace std;

DashBoard::DashBoard(Vehicle &subject) : Observer{&subject} {	
    _subject->subscribe(*this);
}

void DashBoard::update() {	
    // in this case, we just display the info that DashBoard would need from the car
    cout << endl;
    cout << "**DASHBOARD DISPLAY**" << endl;

    // pull the properties of the vehicle	
    cout << "Current speed of vehicle : " << _subject->speed() << endl;		
    cout << "Lights are on : " << std::boolalpha << _subject->lightsOn() << endl;
    cout << "Engine Temperature : " << _subject->engineTemp() << endl;
    cout << "Odometer : " << _subject->odometer() << endl;
    cout << "Fuel Level : " << _subject->fuelLevel() << endl;
    cout << "Time : " << _subject->systemTime() << endl;
}
