#include <iostream>
#include "fleetTracker.h"
#include "subject.h"
#include "vehicle.h"

using namespace std;

FleetTracker::FleetTracker(Vehicle &subject) : Observer{&subject} {	
    _subject->subscribe(*this);
}

void FleetTracker::update() {
    // If this was real, we would update the database of fleet tracking information on this specifc vehicle
    cout << endl;
    cout << "**FLEET TRACKER INFO UPDATE RECEIVED FROM VEHICLE**" << endl;

    // pull the properties of the vehicle
    cout << "Location of vehicle: : " << _subject->position() << endl;
    cout << "Current speed of vehicle : " << _subject->speed() << endl;
    cout << "Current fuel level : " << _subject->fuelLevel() << endl;
    cout << "Doors are locked : " << std::boolalpha << _subject->locked() << endl << endl;
}
