#ifndef _VEHICLE_H_
#define _VEHICLE_H_

#include "subject.h"

class Vehicle : public Subject {
  public:
    Vehicle(double);
    int speed();
    double position(); // kms 
    bool locked();
    void lockedIs(bool); 
    bool lightsOn(); 
    void lightsAre(bool); 
    bool windowsOpen(); 
    void windowsAre(bool); 
    bool wipersOn(); 
    void wipersAre(bool); 
    void openTrunk(); 
    int fuelLevel(); 
    int engineTemp(); 
    long odometer(); 
    long VIN(); 
    int systemTime();

    void turnOnCar();

    // distance, speed (default 50 kmh), at night, in the rain, windows closed
    void driveDistance(int, int = 50, bool = false, bool = false, bool = false);
	
    // etc.. test all properties, covering everything isn't relevant to this assignment

  private:
    int m_speed;
    double m_position;
    bool m_locked;
    bool m_lights;
    int m_fuelLevel;
    bool m_windows; // true if windows are down
    bool m_wipers; // true if wipers on 
    int m_engineTemp; // in degrees celcius room temp when car is off
    long m_odometer; // arbitrary starting value
    long m_vin; // arbitrary 10 digits
    bool m_isOn; //car is off initially 
    int m_systemTime; // would use a time object here, but for demonstration sake...
    double  m_economy; // fuel points/km
}; 

#endif
